// MainForm.cs : Implementation of a sample label using C# and 
// Morovia Barcode DLL.
//
// This file is part of the Morovia Barcode DLL package.
// (c)2006 Morovia Corporation. All rights reserved.
//
// THIS SOURCE FILE IS THE PROPERTY OF MOROVIA CORPORATION AND IS NOT TO 
// BE RE-DISTRIBUTED BY ANY MEANS WHATSOEVER WITHOUT THE EXPRESSED 
// WRITTEN CONSENT OF MOROVIA.
//
// THIS SOURCE CODE CAN ONLY BE USED UNDER THE TERMS AND CONDITIONS 
// OUTLINED IN THE MOROVIA BARCODE COMPONENT LICENSE AGREEMENT.  MOROVIA 
// GRANTS TO YOU (ONE SOFTWARE DEVELOPER) THE LIMITED RIGHT TO USE 
// THIS SOFTWARE ON A SINGLE COMPUTER.
//
// MOROVIA EXPRESSLY DISCLAIMS ANY WARRANTY FOR THE SOFTWARE, DOCUMENTATION
// AND ANYTHING ELSE PROVIDED BY MOROVIA HEREBY AND MOROVIA PROVIDES THE 
// SAME IN "AS IS" CONDITION WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS
// OR IMPLIED, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF 
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
// ARISING OUT OF USE OR PERFORMANCE OF THE SOFTWARE AND DOCUMENTATION 
// REMAINS WITH YOU. 
//
// CONTACT INFORMATION:
// support@morovia.com
// http://www.morovia.com
////////////////////////////////////////////////////////////// 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Printing;

namespace SampleLabel
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnPrintPreview;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnPrint;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox tbSerialNumber;
		private System.Windows.Forms.TextBox tbModelNumber;
		private System.Windows.Forms.TextBox tbUpcCode;
		private System.Windows.Forms.NumericUpDown udPackageIndicator;
		private BarcodeDLLImport _barcode;
		private System.Windows.Forms.Button btnAbout;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this._barcode = new BarcodeDLLImport();
			_barcode.ShowComment=false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnPrintPreview = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.btnPrint = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.tbSerialNumber = new System.Windows.Forms.TextBox();
			this.tbModelNumber = new System.Windows.Forms.TextBox();
			this.tbUpcCode = new System.Windows.Forms.TextBox();
			this.udPackageIndicator = new System.Windows.Forms.NumericUpDown();
			this.btnAbout = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.udPackageIndicator)).BeginInit();
			this.SuspendLayout();
			// 
			// btnPrintPreview
			// 
			this.btnPrintPreview.Location = new System.Drawing.Point(24, 216);
			this.btnPrintPreview.Name = "btnPrintPreview";
			this.btnPrintPreview.Size = new System.Drawing.Size(88, 23);
			this.btnPrintPreview.TabIndex = 0;
			this.btnPrintPreview.Text = "P&rint Preview";
			this.btnPrintPreview.Click += new System.EventHandler(this.btnPrintPreview_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 248);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(384, 40);
			this.label1.TabIndex = 1;
			this.label1.Text = "This program prints a full product label (including barcodes encoding upc-a, scc-" +
				"14, serial number and model number). The scc-14 number is derived from upc-a and" +
				" package indicator.";
			// 
			// btnPrint
			// 
			this.btnPrint.Location = new System.Drawing.Point(128, 216);
			this.btnPrint.Name = "btnPrint";
			this.btnPrint.Size = new System.Drawing.Size(88, 23);
			this.btnPrint.TabIndex = 2;
			this.btnPrint.Text = "&Print";
			this.btnPrint.Click += new System.EventHandler(this.btnPrint_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "Serial Number:";
			this.label2.Click += new System.EventHandler(this.label2_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(28, 77);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(88, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Model Number:";
			this.label3.Click += new System.EventHandler(this.label3_Click);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(28, 114);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(88, 16);
			this.label4.TabIndex = 5;
			this.label4.Text = "UPC Code:";
			this.label4.Click += new System.EventHandler(this.label4_Click);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(12, 151);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(104, 16);
			this.label5.TabIndex = 6;
			this.label5.Text = "Package Indicator:";
			this.label5.Click += new System.EventHandler(this.label5_Click);
			// 
			// tbSerialNumber
			// 
			this.tbSerialNumber.Location = new System.Drawing.Point(128, 40);
			this.tbSerialNumber.Name = "tbSerialNumber";
			this.tbSerialNumber.Size = new System.Drawing.Size(224, 20);
			this.tbSerialNumber.TabIndex = 7;
			this.tbSerialNumber.Text = "PEH050300729";
			// 
			// tbModelNumber
			// 
			this.tbModelNumber.Location = new System.Drawing.Point(128, 72);
			this.tbModelNumber.Name = "tbModelNumber";
			this.tbModelNumber.Size = new System.Drawing.Size(224, 20);
			this.tbModelNumber.TabIndex = 8;
			this.tbModelNumber.Text = "VCDTS232833M";
			// 
			// tbUpcCode
			// 
			this.tbUpcCode.Location = new System.Drawing.Point(128, 104);
			this.tbUpcCode.Name = "tbUpcCode";
			this.tbUpcCode.Size = new System.Drawing.Size(224, 20);
			this.tbUpcCode.TabIndex = 9;
			this.tbUpcCode.Text = "77000707723";
			// 
			// udPackageIndicator
			// 
			this.udPackageIndicator.Location = new System.Drawing.Point(128, 144);
			this.udPackageIndicator.Maximum = new System.Decimal(new int[] {
																			   9,
																			   0,
																			   0,
																			   0});
			this.udPackageIndicator.Name = "udPackageIndicator";
			this.udPackageIndicator.Size = new System.Drawing.Size(56, 20);
			this.udPackageIndicator.TabIndex = 11;
			// 
			// btnAbout
			// 
			this.btnAbout.Location = new System.Drawing.Point(232, 216);
			this.btnAbout.Name = "btnAbout";
			this.btnAbout.Size = new System.Drawing.Size(152, 23);
			this.btnAbout.TabIndex = 13;
			this.btnAbout.Text = "&About Barcode DLL...";
			this.btnAbout.Click += new System.EventHandler(this.btnAbout_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 333);
			this.Controls.Add(this.btnAbout);
			this.Controls.Add(this.udPackageIndicator);
			this.Controls.Add(this.tbUpcCode);
			this.Controls.Add(this.tbModelNumber);
			this.Controls.Add(this.tbSerialNumber);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.btnPrint);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnPrintPreview);
			this.Name = "MainForm";
			this.Text = "Barcode DLL .NET Example (C#)";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.udPackageIndicator)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void label2_Click(object sender, System.EventArgs e)
		{
		
		}

		private void label4_Click(object sender, System.EventArgs e)
		{
		
		}

		private void label5_Click(object sender, System.EventArgs e)
		{
		
		}

		private void label3_Click(object sender, System.EventArgs e)
		{
		
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
		
		}

		private CaseCodeLabel GetCaseCodeLabel()
		{
			string upc_number = tbUpcCode.Text;
			string scc14 = udPackageIndicator.Value.ToString() + "0" + upc_number;
			if ( scc14.Length > 13 ) 
				scc14 = scc14.Substring(13);
			
			//calculate the SCC14 checksum
			int checksum=0;
			for(int i=0; i<13; i++)
			{
				if ( i%2==0 )
					checksum += (scc14[12-i]-'0')*3;
				else
					checksum += (scc14[12-i]-'0')*1;
			}
			checksum = 10 - (checksum % 10 );
			if (checksum==10 ) checksum=0;

			string chChecksum = checksum.ToString();
			scc14 += chChecksum;

			string scc14_format = scc14.Substring(0,1) + " " +
				scc14.Substring(1, 2) + " " +
				scc14.Substring(3, 5) + " " +
				scc14.Substring(8, 5) + " " +
				scc14.Substring(13, 1);	

			CaseCodeLabel cl = new CaseCodeLabel(upc_number,
				scc14_format, tbModelNumber.Text, tbSerialNumber.Text, _barcode);
			return cl;
		}

		private void btnPrintPreview_Click(object sender, System.EventArgs e)
		{
			CaseCodeLabel cl = GetCaseCodeLabel();
			cl.ShowPreview();
		}

		private void btnAbout_Click(object sender, System.EventArgs e)
		{
			_barcode.About();
        }

		private void btnPrint_Click(object sender, System.EventArgs e)
		{
			CaseCodeLabel cl = GetCaseCodeLabel();
			cl.PrintDirect();
		}
	}
}
