// MFCSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCSample.h"
#include "MFCSampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCSampleDlg dialog

CMFCSampleDlg::CMFCSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFCSampleDlg)
	m_strMessage = _T("MOROVIA");
	m_strComment = _T("(c)2006, 2021 Morovia Corporation. All rights reserved.");
	m_uiNarrowBarWidth = 13;
	m_uiBarHeight = 1000;
	m_iMeasurement = 0;
	m_bShowComment = FALSE;
	m_bShowHR = TRUE;
	m_bBearerBars = FALSE;
	m_bQuietZones = FALSE;
	m_lSysMarginTop = 100;
	m_lSysMarginBottom = 100;
	m_lSysMarginLeft = 100;
	m_lSysMarginRight = 100;
	m_bCommentOnTop = FALSE;
	m_bHROnTop = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFCSampleDlg)
	DDX_Control(pDX, IDC_COMBO_BORDERSTYLE, m_comboBorderStyle);
	DDX_Control(pDX, IDC_COMBO_BORDERCOLOR, m_comboBorderColor);
	DDX_Control(pDX, IDC_BARCODE, m_picBarcode);
	DDX_Control(pDX, IDC_COMBO_BACKCOLOR, m_comboBackColor);
	DDX_Control(pDX, IDC_COMBO_FORECOLOR, m_comboForeColor);
	DDX_Control(pDX, IDC_COMBO_ROTATION, m_comboRotation);
	DDX_Control(pDX, IDC_COMBO_SYMBOLOGY, m_comboBoxSymbology);
	DDX_Text(pDX, IDC_EDIT_MESSAGE, m_strMessage);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_strComment);
	DDX_Text(pDX, IDC_EDIT_NARROWBARWIDTH, m_uiNarrowBarWidth);
	DDX_Text(pDX, IDC_EDIT_BARHEIGHT, m_uiBarHeight);
	DDX_Radio(pDX, IDC_RADIO_MEASUREENGLISH, m_iMeasurement);
	DDX_Check(pDX, IDC_CHECK_SHOWCOMMENT, m_bShowComment);
	DDX_Check(pDX, IDC_CHECK_SHOWHR, m_bShowHR);
	DDX_Check(pDX, IDC_CHECK_BEARERBARS, m_bBearerBars);
	DDX_Check(pDX, IDC_CHECK_QUIETZONES, m_bQuietZones);
	DDX_Text(pDX, IDC_EDIT_SYSMARGINTOP, m_lSysMarginTop);
	DDX_Text(pDX, IDC_EDIT_SYSMARGINBOTTOM, m_lSysMarginBottom);
	DDX_Text(pDX, IDC_EDIT_SYSMARGINLEFT, m_lSysMarginLeft);
	DDX_Text(pDX, IDC_EDIT_SYSMARGINRIGHT, m_lSysMarginRight);
	DDX_Check(pDX, IDC_CHECK_COMMENTONTOP, m_bCommentOnTop);
	DDX_Check(pDX, IDC_CHECK_HRONTOP, m_bHROnTop);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFCSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CMFCSampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_ABOUT, OnButtonAbout)
	ON_BN_CLICKED(IDC_BUTTON_REFRESH, OnButtonRefresh)
	ON_BN_CLICKED(IDC_BUTTON_EXPORTIMAGE, OnButtonExportimage)
	ON_BN_CLICKED(IDC_BUTTON_LOAD, OnButtonLoad)
	ON_BN_CLICKED(IDC_BUTTON_SAVE, OnButtonSave)
	ON_CBN_SELENDOK(IDC_COMBO_SYMBOLOGY, OnSelendokComboSymbology)
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_CHECK_SHOWCOMMENT, IDC_CHECK_HRONTOP, OnCheckOptions)
	ON_CONTROL_RANGE(EN_KILLFOCUS, IDC_EDIT_SYSMARGINTOP, IDC_EDIT_SYSMARGINRIGHT, OnSysMarginChange)
	ON_CBN_SELENDOK(IDC_COMBO_BACKCOLOR, OnSelendokComboBackcolor)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_RADIO_MEASUREENGLISH, IDC_RADIO_MEASUREMETRICS, OnChangeMeasurement)
	ON_CBN_SELENDOK(IDC_COMBO_BORDERCOLOR, OnSelendokComboBordercolor)
	ON_CBN_SELENDOK(IDC_COMBO_BORDERSTYLE, OnSelendokComboBorderstyle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCSampleDlg message handlers

BOOL CMFCSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Create a barcode object and save the handle
	m_hBarcodeDLL=CreateBarcodeObject("Your License To", "Your Regcode");

	int index=m_comboBoxSymbology.AddString(L"Code 39"); 
	m_comboBoxSymbology.SetItemData(index, mbxCode39);
	m_comboBoxSymbology.SetCurSel(0);
	index=m_comboBoxSymbology.AddString(L"Code 39 Full ASCII"); m_comboBoxSymbology.SetItemData(index, mbxCode39_Full_ASCII);
	index=m_comboBoxSymbology.AddString(L"Code 39 HIBC"); m_comboBoxSymbology.SetItemData(index, mbxCode39_HIBC);
	index=m_comboBoxSymbology.AddString(L"Codabar"); m_comboBoxSymbology.SetItemData(index, mbxCodaBar);
	index=m_comboBoxSymbology.AddString(L"Code 93"); m_comboBoxSymbology.SetItemData(index, mbxCode93);
	index=m_comboBoxSymbology.AddString(L"Code 128"); m_comboBoxSymbology.SetItemData(index, mbxCode128);
	index=m_comboBoxSymbology.AddString(L"Code UCC/EAN128"); m_comboBoxSymbology.SetItemData(index, mbxUCC_EAN_128);
	index=m_comboBoxSymbology.AddString(L"Interleaved 2 of 5"); m_comboBoxSymbology.SetItemData(index, mbxInterleaved_2of5);
	index=m_comboBoxSymbology.AddString(L"UPC-A"); m_comboBoxSymbology.SetItemData(index, mbxUPC_A);
	index=m_comboBoxSymbology.AddString(L"UPC-E"); m_comboBoxSymbology.SetItemData(index, mbxUPC_E);
	index=m_comboBoxSymbology.AddString(L"EAN-13"); m_comboBoxSymbology.SetItemData(index, mbxEAN_13);
	index=m_comboBoxSymbology.AddString(L"EAN-8"); m_comboBoxSymbology.SetItemData(index, mbxEAN_8);
	index=m_comboBoxSymbology.AddString(L"Bookland"); m_comboBoxSymbology.SetItemData(index, mbxBookland);
	index=m_comboBoxSymbology.AddString(L"Telepen"); m_comboBoxSymbology.SetItemData(index, mbxTelepen);
	index=m_comboBoxSymbology.AddString(L"Telepen Numeric"); m_comboBoxSymbology.SetItemData(index, mbxTelepenNumeric);
	index=m_comboBoxSymbology.AddString(L"Postnet"); m_comboBoxSymbology.SetItemData(index, mbxPostnet);
	index=m_comboBoxSymbology.AddString(L"Planet"); m_comboBoxSymbology.SetItemData(index, mbxPlanet);
	index=m_comboBoxSymbology.AddString(L"Royal Mail"); m_comboBoxSymbology.SetItemData(index, mbxRoyalMail);
	index=m_comboBoxSymbology.AddString(L"MSI/Plessey"); m_comboBoxSymbology.SetItemData(index, mbxMSI_Plessey);
	index=m_comboBoxSymbology.AddString(L"Code 25"); m_comboBoxSymbology.SetItemData(index, mbxCode25);
	index=m_comboBoxSymbology.AddString(L"Code 11"); m_comboBoxSymbology.SetItemData(index, mbxCode11);

	/* added since V3.4  GS1 DataBar Symbologies */
	index=m_comboBoxSymbology.AddString(L"DataBar"); m_comboBoxSymbology.SetItemData(index, mbxDataBar);
	index=m_comboBoxSymbology.AddString(L"DataBar Truncated"); m_comboBoxSymbology.SetItemData(index, mbxDataBarTruncated);
	index=m_comboBoxSymbology.AddString(L"DataBar Stacked"); m_comboBoxSymbology.SetItemData(index, mbxDataBarStacked);
	index=m_comboBoxSymbology.AddString(L"DataBar Stacked Omni"); m_comboBoxSymbology.SetItemData(index, mbxDataBarStackedOmni);
	index=m_comboBoxSymbology.AddString(L"DataBar Limited"); m_comboBoxSymbology.SetItemData(index, mbxDataBarLimited);
	index=m_comboBoxSymbology.AddString(L"DataBar Expanded"); m_comboBoxSymbology.SetItemData(index, mbxDataBarExpanded);

	index=m_comboBoxSymbology.AddString(L"PDF417"); m_comboBoxSymbology.SetItemData(index, mbxPDF417);
	index=m_comboBoxSymbology.AddString(L"DataMatrix"); m_comboBoxSymbology.SetItemData(index, mbxDataMatrix);
	index=m_comboBoxSymbology.AddString(L"MaxiCode"); m_comboBoxSymbology.SetItemData(index, mbxMaxiCode);

	index = m_comboRotation.AddString(L"0 degrees"); m_comboRotation.SetItemData(index, mbxRTZeroDegree);
	m_comboRotation.SetCurSel(index);
	index=m_comboRotation.AddString(L"90 degrees");m_comboRotation.SetItemData(index, mbxRTAntiClockwise_90);
	index=m_comboRotation.AddString(L"180 degrees");m_comboRotation.SetItemData(index, mbxRTAntiClockwise_180);
	index=m_comboRotation.AddString(L"270 degrees");m_comboRotation.SetItemData(index, mbxRTAntiClockwise_270);

	//set forecolor
	index = m_comboForeColor.AddString(L"black"); m_comboForeColor.SetItemData(index, RGB(0,0,0));
	index = m_comboForeColor.AddString(L"red"); m_comboForeColor.SetItemData(index, RGB(255,0,0));
	index = m_comboForeColor.AddString(L"blue"); m_comboForeColor.SetItemData(index, RGB(0,0,255));
	index = m_comboForeColor.AddString(L"green"); m_comboForeColor.SetItemData(index, RGB(0,255,0));
	m_comboForeColor.SetCurSel(0);

	//set backcolor
	index = m_comboBackColor.AddString(L"white"); m_comboBackColor.SetItemData(index, RGB(255,255,255));
	index = m_comboBackColor.AddString(L"red"); m_comboBackColor.SetItemData(index, RGB(255,0,0));
	index = m_comboBackColor.AddString(L"blue"); m_comboBackColor.SetItemData(index, RGB(0,0,255));
	index = m_comboBackColor.AddString(L"green"); m_comboBackColor.SetItemData(index, RGB(0,255,0));
	m_comboBackColor.SetCurSel(0);

	//set bordercolor
	index = m_comboBorderColor.AddString(L"black"); m_comboBorderColor.SetItemData(index, RGB(0,0,0));
	index = m_comboBorderColor.AddString(L"red"); m_comboBorderColor.SetItemData(index, RGB(255,0,0));
	index = m_comboBorderColor.AddString(L"blue"); m_comboBorderColor.SetItemData(index, RGB(0,0,255));
	index = m_comboBorderColor.AddString(L"green"); m_comboBorderColor.SetItemData(index, RGB(0,255,0));
	m_comboBorderColor.SetCurSel(0);

	//set border style
	index = m_comboBorderStyle.AddString(L"mbxBorderStyleNone"); m_comboBorderStyle.SetItemData(index, 0);
	index = m_comboBorderStyle.AddString(L"mbxBorderStyleSolid"); m_comboBorderStyle.SetItemData(index, 1);
	index = m_comboBorderStyle.AddString(L"mbxBorderStyleDash"); m_comboBorderStyle.SetItemData(index, 2);
	index = m_comboBorderStyle.AddString(L"mbxBorderStyleDot"); m_comboBorderStyle.SetItemData(index, 3);
	index = m_comboBorderStyle.AddString(L"mbxBorderStyleDashDot"); m_comboBorderStyle.SetItemData(index, 4);
	index = m_comboBorderStyle.AddString(L"mbxBorderStyleDashDotDot"); m_comboBorderStyle.SetItemData(index, 5);
	m_comboBorderStyle.SetCurSel(0);

	//put sysmargins
	put_SymbolMarginTop(m_hBarcodeDLL, m_lSysMarginTop);
	put_SymbolMarginBottom(m_hBarcodeDLL, m_lSysMarginBottom);
	put_SymbolMarginLeft(m_hBarcodeDLL, m_lSysMarginLeft);
	put_SymbolMarginRight(m_hBarcodeDLL, m_lSysMarginRight);

	//sync properties
	bool vbTemp;
	get_ShowComment(m_hBarcodeDLL, &vbTemp);
	m_bShowComment = vbTemp?TRUE:FALSE;
	get_ShowHRText(m_hBarcodeDLL, &vbTemp);
	m_bShowHR = vbTemp?TRUE:FALSE;
	get_BearerBars(m_hBarcodeDLL, &vbTemp);
	m_bBearerBars = vbTemp?TRUE:FALSE;
	get_QuietZones(m_hBarcodeDLL, &vbTemp);
	m_bQuietZones = vbTemp?TRUE:FALSE;
	get_CommentOnTop(m_hBarcodeDLL, &vbTemp);
	m_bCommentOnTop = vbTemp?TRUE:FALSE;
	get_TextOnTop(m_hBarcodeDLL, &vbTemp);
	m_bHROnTop = vbTemp?TRUE:FALSE;

	UpdateData(FALSE);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFCSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		OnButtonRefresh();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMFCSampleDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	::DestroyBarcodeObject(m_hBarcodeDLL);	
}


void CMFCSampleDlg::OnButtonAbout() 
{
	mbxAbout(m_hBarcodeDLL);
}

// draw the barcode on the picture box
void CMFCSampleDlg::OnButtonRefresh() 
{
	USES_CONVERSION;

	//step 1 - retrieve the values from the dialog and set the barcode object properties
	UpdateData(TRUE);

	try
	{
		HRESULT hr = put_Message(m_hBarcodeDLL, W2A(m_strMessage.GetBuffer()));
		if ( FAILED(hr) ) throw hr;

		int index = m_comboRotation.GetCurSel();
		long data = (LONG)m_comboRotation.GetItemData(index);

		hr = put_Rotation(m_hBarcodeDLL, data);
		if ( FAILED(hr) ) throw hr;

		index = m_comboForeColor.GetCurSel();
		data = (long)m_comboForeColor.GetItemData(index);
		hr = put_ForeColor(m_hBarcodeDLL, data);
		if ( FAILED(hr) ) throw hr;

		index = m_comboBackColor.GetCurSel();
		data = (long)m_comboBackColor.GetItemData(index);
		hr = put_BackColor(m_hBarcodeDLL, data);
		if ( FAILED(hr) ) throw hr;

		hr = put_NarrowBarWidth(m_hBarcodeDLL, m_uiNarrowBarWidth);	
		if ( FAILED(hr) ) throw hr;

		hr = put_BarHeight(m_hBarcodeDLL, m_uiBarHeight);
		if ( FAILED(hr) ) throw hr;

		hr = put_Comment(m_hBarcodeDLL, W2A(m_strComment.GetBuffer()));
		if ( FAILED(hr) ) throw hr;

		//step 2 - draw the area using retrieved emf handle
		CDC* pDC = m_picBarcode.GetDC();

		IPictureDisp* pPictureDisp=NULL;
		hr = get_Picture(m_hBarcodeDLL, &pPictureDisp);
		if ( FAILED(hr) ) throw hr;

		IPicture* pPicture=NULL;
		hr = pPictureDisp->QueryInterface(__uuidof(IPicture), (void**)&pPicture);
		ASSERT(SUCCEEDED(hr));

		// Draw the Bar Code into static frame
		OLE_HANDLE handle;
		pPicture->get_Handle(&handle);
		OLE_YSIZE_HIMETRIC height;
		OLE_XSIZE_HIMETRIC width; 
		pPicture->get_Height(&height);
		pPicture->get_Width(&width);

		CRect rcBounds;
		m_picBarcode.GetClientRect(&rcBounds);

		//paint background first
		CBrush brush;
		brush.CreateSolidBrush(RGB(255,255,255));

		CBrush* pOldBrush = pDC->SelectObject(&brush);
		pDC->FillRect(&rcBounds, &brush);

		pDC->SetMapMode(MM_HIMETRIC);
		pDC->DPtoLP(&rcBounds);
		rcBounds.bottom = rcBounds.top - height;
		rcBounds.right = rcBounds.left + width;

		::PlayEnhMetaFile(pDC->m_hDC, (HENHMETAFILE)LongToPtr(handle), &rcBounds);

		pPictureDisp->Release();
		pPicture->Release();
		pDC->SelectObject(pOldBrush);
		pDC->SetMapMode(MM_TEXT);
		m_picBarcode.ReleaseDC(pDC);
	}
	catch (HRESULT hresult)
	{
		//Display error message
		char sError[1024];
		GetLastBarcodeErrorMessage(m_hBarcodeDLL, sError);
		CString strMsg;
		strMsg.Format(L"Error code %d.\r\n%S.", 
						HRESULT_CODE(hresult),
			sError);
		AfxMessageBox(strMsg);

	}
}

void CMFCSampleDlg::OnButtonExportimage() 
{
	USES_CONVERSION;
	static wchar_t BASED_CODE szFilter[] = L"Graphics Files(*.bmp)(*.jpg)(*.wmf)(*.gif)(*.tif)|"
										L"*.bmp;*.emf;*.wmf;*.jpg;*.gif;*.tif||";
	CFileDialog dlg(FALSE, L"jpg", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, this);
	if ( dlg.DoModal()==IDOK )
	{
		CString ext = dlg.GetFileExt();
		CString strPath = dlg.GetFileName()+"."+ext;
		long image_format = 0;
		if ( dlg.GetFileExt().CompareNoCase(L"bmp")==0 )
			image_format = mbxFormatBMP;
		else if ( dlg.GetFileExt().CompareNoCase(L"jpg")==0 )
			image_format = mbxFormatJPG;
		else if ( dlg.GetFileExt().CompareNoCase(L"gif")==0 )
			image_format = mbxFormatGIF;
		else if ( dlg.GetFileExt().CompareNoCase(L"tif")==0 )
			image_format = mbxFormatTIF;
		else if ( dlg.GetFileExt().CompareNoCase(L"png")==0 )
			image_format = mbxFormatPNG;
		else if ( dlg.GetFileExt().CompareNoCase(L"wmf")==0 )
			image_format = mbxFormatWMF;
		else if ( dlg.GetFileExt().CompareNoCase(L"emf")==0 )
			image_format = mbxFormatEMF;

		mbxExportImage(m_hBarcodeDLL, W2A(strPath.GetBuffer()), image_format);
	}	
}

void CMFCSampleDlg::OnButtonLoad() 
{
	USES_CONVERSION;
	static wchar_t BASED_CODE szFilter[] = L"Barcode Files (*.mbx)|*.mbx|Barcode Files (*.xml)|*.xml|All Files (*.*)|*.*||";
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, this);
	if ( dlg.DoModal()==IDOK )
	{
		CString strPath = dlg.GetPathName();
		CString ext = dlg.GetFileExt();
		if ( dlg.GetFileExt().CompareNoCase(L"xml")== 0 )
			mbxLoad(m_hBarcodeDLL, W2A(strPath.GetBuffer()), mbxPersistXML );
		else
			mbxLoad(m_hBarcodeDLL, W2A(strPath.GetBuffer()), mbxPersistBinary);

		char sMessage[1024];
		get_Message(m_hBarcodeDLL, sMessage);
		OnButtonRefresh();
	}
}

void CMFCSampleDlg::OnButtonSave() 
{
	USES_CONVERSION;

	static wchar_t BASED_CODE szFilter[] = L"Barcode Files Binary(*.mbx)|*.mbx|Barcode Files XML(*.xml)|*.xml|All Files (*.*)|*.*||";
	CFileDialog dlg(FALSE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, this);
	if ( dlg.DoModal()==IDOK )
	{
		CString ext = dlg.GetFileExt();
		CString strPath = dlg.GetFileName()+L"."+ext;
		if ( dlg.GetFileExt().CompareNoCase(L"xml")== 0 )
			mbxSave(m_hBarcodeDLL, W2A(strPath.GetBuffer()), mbxPersistXML );
		else
			mbxSave(m_hBarcodeDLL, W2A(strPath.GetBuffer()), mbxPersistBinary);
	}
	
}

void CMFCSampleDlg::OnSelendokComboSymbology() 
{
	int sel = m_comboBoxSymbology.GetCurSel();
	long symbology = (long)m_comboBoxSymbology.GetItemData(sel);
	put_Symbology(m_hBarcodeDLL, symbology);

	// When the symbology property changes, the Message property will change as well
	// we need to retrieve the Message.
	char s[1024];
	get_Message(m_hBarcodeDLL, s);
	m_strMessage = s;
	UpdateData(FALSE);	
	OnButtonRefresh();
}

void CMFCSampleDlg::OnPrint() 
{
	CDC dc;
	CPrintDialog dlg(FALSE);
	DOCINFO di;

	dlg.GetDefaults();
	dc.Attach(dlg.GetPrinterDC());
	
	memset(&di,0,sizeof(di));
	di.cbSize = sizeof(DOCINFO);
	
	// Print Job Name
	di.lpszDocName = L"MFC Sample for Morovia Barcode DLL";
	
	if (dc.StartDoc(&di) > 0)
	{
		dc.StartPage();
		
		IPictureDisp* pPictureDisp=NULL;
		HRESULT hr = get_Picture(m_hBarcodeDLL, &pPictureDisp);
		ASSERT(SUCCEEDED(hr));

		IPicture* pPicture=NULL;
		hr = pPictureDisp->QueryInterface(__uuidof(IPicture), (void**)&pPicture);
		ASSERT(SUCCEEDED(hr));

		// Draw the Bar Code into the Printer DC
		OLE_HANDLE handle;
		pPicture->get_Handle(&handle);
		OLE_YSIZE_HIMETRIC height;
		OLE_XSIZE_HIMETRIC width; 
		pPicture->get_Height(&height);
		pPicture->get_Width(&width);

		dc.SetMapMode(MM_HIMETRIC);

		CRect rcBounds;
		rcBounds.top=-1000; rcBounds.left=1000;
		rcBounds.bottom = rcBounds.top - height;
		rcBounds.right = rcBounds.left + width;
		::PlayEnhMetaFile(dc.m_hDC, (HENHMETAFILE)LongToPtr(handle), &rcBounds);
		
		// Release Picture object
		pPicture->Release();
		pPictureDisp->Release();

		// Eject the Page and Leave.
		dc.EndPage();
		
		dc.EndDoc();
	}	
}

void CMFCSampleDlg::OnCheckOptions(UINT id)
{
	UpdateData(TRUE);
	UNREFERENCED_PARAMETER(id);

	if ( id == IDC_CHECK_SHOWCOMMENT )
		put_ShowComment(m_hBarcodeDLL, m_bShowComment != 0);
	else if ( id==IDC_CHECK_SHOWHR)
		put_ShowHRText(m_hBarcodeDLL, m_bShowHR != 0);
	else if ( id==IDC_CHECK_BEARERBARS)
		put_BearerBars(m_hBarcodeDLL, m_bBearerBars != 0);
	else if ( id==IDC_CHECK_QUIETZONES)
		put_QuietZones(m_hBarcodeDLL, m_bQuietZones != 0);
	else if ( id==IDC_CHECK_HRONTOP)
		put_TextOnTop(m_hBarcodeDLL, m_bHROnTop != 0);
	else if ( id==IDC_CHECK_COMMENTONTOP)
		put_CommentOnTop(m_hBarcodeDLL, m_bCommentOnTop != 0);
	OnButtonRefresh();
}

void CMFCSampleDlg::OnSysMarginChange(UINT id)
{
	UpdateData(TRUE);
	if ( id==IDC_EDIT_SYSMARGINTOP)
		put_SymbolMarginTop(m_hBarcodeDLL, m_lSysMarginTop);
	else if (id==IDC_EDIT_SYSMARGINBOTTOM)
		put_SymbolMarginBottom(m_hBarcodeDLL, m_lSysMarginBottom);
	else if (id==IDC_EDIT_SYSMARGINLEFT)
		put_SymbolMarginLeft(m_hBarcodeDLL, m_lSysMarginLeft);
	else if ( id==IDC_EDIT_SYSMARGINRIGHT)
		put_SymbolMarginRight(m_hBarcodeDLL, m_lSysMarginRight);
	OnButtonRefresh();
}

void CMFCSampleDlg::OnSelendokComboBackcolor() 
{
	int sel = m_comboBackColor.GetCurSel();
	long color = (long)m_comboBackColor.GetItemData(sel);

	put_BackColor(m_hBarcodeDLL, color);	
	OnButtonRefresh();
}

void CMFCSampleDlg::OnChangeMeasurement(UINT id)
{
	UpdateData(TRUE);
	UNREFERENCED_PARAMETER(id);
	put_Measurement(m_hBarcodeDLL, m_iMeasurement);

	//when measurement changes, all length units will change as well,
	//so we need to retrieve these properties
	get_NarrowBarWidth(m_hBarcodeDLL, (LONG*)&m_uiNarrowBarWidth);
	get_BarHeight(m_hBarcodeDLL, (LONG*)&m_uiBarHeight);
	get_SymbolMarginTop(m_hBarcodeDLL, &m_lSysMarginTop);
	get_SymbolMarginBottom(m_hBarcodeDLL, &m_lSysMarginBottom);
	get_SymbolMarginLeft(m_hBarcodeDLL, &m_lSysMarginLeft);
	get_SymbolMarginRight(m_hBarcodeDLL, &m_lSysMarginRight);

	UpdateData(FALSE);
	OnButtonRefresh();
}

void CMFCSampleDlg::OnSelendokComboBordercolor() 
{
	int sel = m_comboBorderStyle.GetCurSel();
	put_BorderStyle(m_hBarcodeDLL, (long)m_comboBorderStyle.GetItemData(sel));
	OnButtonRefresh();
}

void CMFCSampleDlg::OnSelendokComboBorderstyle() 
{
	int sel = m_comboBorderColor.GetCurSel();
	put_BorderColor(m_hBarcodeDLL, (long)m_comboBorderColor.GetItemData(sel));
	
	OnButtonRefresh();
}
