#ifndef MRVBARDLL_H_
#define MRVBARDLL_H_

/***************************************************************************
 mrvbardll.h : header file for functions exported from mrvbardll.dll. Use in 
 conjunction with mrvbardll.lib in Microsoft C/C++ compiler (tested on VC6 and VC71)

 This file is a part of the Morovia Barcode DLL package.
 (c)2006, 2008, 2021 Morovia Corporation. All rights reserved.

 THIS SOURCE FILE IS THE PROPERTY OF MOROVIA CORPORATION AND IS NOT TO 
 BE RE-DISTRIBUTED BY ANY MEANS WHATSOEVER WITHOUT THE EXPRESSED 
 WRITTEN CONSENT OF MOROVIA.

 THIS SOURCE CODE CAN ONLY BE USED UNDER THE TERMS AND CONDITIONS 
 OUTLINED IN THE MOROVIA BARCODE COMPONENT LICENSE AGREEMENT.  MOROVIA 
 GRANTS TO YOU (ONE SOFTWARE DEVELOPER) THE LIMITED RIGHT TO USE 
 THIS SOFTWARE ON A SINGLE COMPUTER.

 MOROVIA EXPRESSLY DISCLAIMS ANY WARRANTY FOR THE SOFTWARE, DOCUMENTATION
 AND ANYTHING ELSE PROVIDED BY MOROVIA HEREBY AND MOROVIA PROVIDES THE 
 SAME IN "AS IS" CONDITION WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS
 OR IMPLIED, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF 
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
 ARISING OUT OF USE OR PERFORMANCE OF THE SOFTWARE AND DOCUMENTATION 
 REMAINS WITH YOU. 

 CONTACT INFORMATION:
 support@morovia.com
 http://www.morovia.com
********************************************************************************/

/* $LastChangedDate: 2021-06-15 16:39:18 -0400 (Tue, 15 Jun 2021) $ */
/* $Revision: 11500 $ */

#pragma comment(lib, "MrvBardll.lib")

#include <windows.h>
#include <ocidl.h>

#ifdef __cplusplus
extern "C" {
#endif

HANDLE __stdcall CreateBarcodeObject(const char* lpszLicenseTo,  const char* lpszRegCode);
bool   __stdcall IsBarcodeObjectDemo(HANDLE handle);
void   __stdcall DestroyBarcodeObject(HANDLE ha);
bool   __stdcall GetLastBarcodeErrorMessage(HANDLE handle, char* lpszErrorMsg);
HRESULT __stdcall get_AutoSize(HANDLE handle, bool* pVal);
HRESULT __stdcall put_AutoSize(HANDLE handle, bool val);
HRESULT __stdcall get_BackColor(HANDLE handle, OLE_COLOR* pVal);
HRESULT __stdcall put_BackColor(HANDLE handle, OLE_COLOR color);
HRESULT __stdcall get_BorderColor(HANDLE handle, OLE_COLOR* pVal);
HRESULT __stdcall put_BorderColor(HANDLE handle, OLE_COLOR color);
HRESULT __stdcall get_BorderStyle(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_BorderStyle(HANDLE handle, LONG val);
HRESULT __stdcall get_BorderWidth(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_BorderWidth(HANDLE handle, LONG val);
HRESULT __stdcall get_Font(HANDLE handle, IFontDisp** pVal);
HRESULT __stdcall put_Font(HANDLE handle, IFontDisp* val);
HRESULT __stdcall get_ForeColor(HANDLE handle, OLE_COLOR* pVal);
HRESULT __stdcall put_ForeColor(HANDLE handle, OLE_COLOR color);
HRESULT __stdcall get_Comment(HANDLE handle, char* lppszValue);
HRESULT __stdcall put_Comment(HANDLE handle, const char* lpszValue);
HRESULT __stdcall get_CommentFont(HANDLE handle, IFontDisp** pVal);
HRESULT __stdcall put_CommentFont(HANDLE handle, IFontDisp* val);
HRESULT __stdcall get_ShowComment(HANDLE handle, bool* pVal);
HRESULT __stdcall put_ShowComment(HANDLE handle, bool val);
HRESULT __stdcall get_CommentOnTop(HANDLE handle, bool* pVal);
HRESULT __stdcall put_CommentOnTop(HANDLE handle, bool val);
HRESULT __stdcall get_CommentAlignment(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_CommentAlignment(HANDLE handle, LONG val);
HRESULT __stdcall get_CommentMarginLeft(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_CommentMarginLeft(HANDLE handle, LONG val);
HRESULT __stdcall get_CommentMarginRight(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_CommentMarginRight(HANDLE handle, LONG val);
HRESULT __stdcall get_CommentMarginTop(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_CommentMarginTop(HANDLE handle, LONG val);
HRESULT __stdcall get_CommentMarginBottom(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_CommentMarginBottom(HANDLE handle, LONG val);
HRESULT __stdcall get_BarHeight(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_BarHeight(HANDLE handle, LONG val);
HRESULT __stdcall get_BearerBars(HANDLE handle, bool* pVal);
HRESULT __stdcall put_BearerBars(HANDLE handle, bool val);
HRESULT __stdcall get_Measurement(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_Measurement(HANDLE handle, LONG val);
HRESULT __stdcall get_Message(HANDLE handle, char* lppszValue);
HRESULT __stdcall put_Message(HANDLE handle, const char* lpszValue);
HRESULT __stdcall get_NarrowBarWidth(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_NarrowBarWidth(HANDLE handle, LONG val);
HRESULT __stdcall get_NarrowToWideRatio(HANDLE handle, double* pVal);
HRESULT __stdcall put_NarrowToWideRatio(HANDLE handle, double val);
HRESULT __stdcall get_Symbology(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_Symbology(HANDLE handle, LONG val);
HRESULT __stdcall get_QuietZones(HANDLE handle, bool* pVal);
HRESULT __stdcall put_QuietZones(HANDLE handle, bool val);
HRESULT __stdcall get_Code39OptionalCheckDigit(HANDLE handle, bool* pVal);
HRESULT __stdcall put_Code39OptionalCheckDigit(HANDLE handle, bool val);
HRESULT __stdcall get_I2of5OptionalCheckDigit(HANDLE handle, bool* pVal);
HRESULT __stdcall put_I2of5OptionalCheckDigit(HANDLE handle, bool val);
HRESULT __stdcall get_Code25OptionalCheckDigit(HANDLE handle, bool* pVal);
HRESULT __stdcall put_Code25OptionalCheckDigit(HANDLE handle, bool val);
HRESULT __stdcall get_UccEanOptionalCheckDigit(HANDLE handle, bool* pVal);
HRESULT __stdcall put_UccEanOptionalCheckDigit(HANDLE handle, bool val);
HRESULT __stdcall get_ShowHRText(HANDLE handle, bool* pVal);
HRESULT __stdcall put_ShowHRText(HANDLE handle, bool val);
HRESULT __stdcall get_TexAlignment(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_TexAlignment(HANDLE handle, LONG val);
HRESULT __stdcall get_Code39StartStopChars(HANDLE handle, bool* pVal);
HRESULT __stdcall put_Code39StartStopChars(HANDLE handle, bool val);
HRESULT __stdcall get_TextOnTop(HANDLE handle, bool* pVal);
HRESULT __stdcall put_TextOnTop(HANDLE handle, bool val);
HRESULT __stdcall get_ShowCheckDigit(HANDLE handle, bool* pVal);
HRESULT __stdcall put_ShowCheckDigit(HANDLE handle, bool val);
HRESULT __stdcall get_SymbolMarginBottom(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_SymbolMarginBottom(HANDLE handle, LONG val);
HRESULT __stdcall get_SymbolMarginLeft(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_SymbolMarginLeft(HANDLE handle, LONG val);
HRESULT __stdcall get_SymbolMarginRight(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_SymbolMarginRight(HANDLE handle, LONG val);
HRESULT __stdcall get_SymbolMarginTop(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_SymbolMarginTop(HANDLE handle, LONG val);
HRESULT __stdcall get_AutoLabelSize(HANDLE handle, bool* pVal);
HRESULT __stdcall put_AutoLabelSize(HANDLE handle, bool val);
HRESULT __stdcall get_LabelHeight(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_LabelHeight(HANDLE handle, LONG val);
HRESULT __stdcall get_LabelWidth(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_LabelWidth(HANDLE handle, LONG val);
HRESULT __stdcall get_Rotation(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_Rotation(HANDLE handle, LONG val);
HRESULT __stdcall get_ZoomRatio(HANDLE handle, double* pVal);
HRESULT __stdcall put_ZoomRatio(HANDLE handle, double val);
HRESULT __stdcall get_RasterImageResolution(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_RasterImageResolution(HANDLE handle, LONG val);
HRESULT __stdcall get_DataMatrixTargetSizeID(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_DataMatrixTargetSizeID(HANDLE handle, LONG val);
HRESULT __stdcall get_DataMatrixModuleSize(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_DataMatrixModuleSize(HANDLE handle, LONG val);
HRESULT __stdcall get_PDFAspectRatio(HANDLE handle, double* pVal);
HRESULT __stdcall put_PDFAspectRatio(HANDLE handle, double val);
HRESULT __stdcall get_PDFMaxCols(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_PDFMaxCols(HANDLE handle, LONG val);
HRESULT __stdcall get_PDFMaxRows(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_PDFMaxRows(HANDLE handle, LONG val);
HRESULT __stdcall get_PDFModuleHeight(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_PDFModuleHeight(HANDLE handle, LONG val);
HRESULT __stdcall get_PDFModuleWidth(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_PDFModuleWidth(HANDLE handle, LONG val);
HRESULT __stdcall get_PDFSecurityLevel(HANDLE handle, SHORT* pVal);
HRESULT __stdcall put_PDFSecurityLevel(HANDLE handle, SHORT val);
HRESULT __stdcall get_PDFTruncatedSymbol(HANDLE handle, bool* pVal);
HRESULT __stdcall put_PDFTruncatedSymbol(HANDLE handle, bool val);
HRESULT __stdcall get_MaxicodeClass(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_MaxicodeClass(HANDLE handle, LONG val);
HRESULT __stdcall get_MaxicodeMode(HANDLE handle, SHORT* pVal);
HRESULT __stdcall put_MaxicodeMode(HANDLE handle, SHORT val);
HRESULT __stdcall get_MaxicodeCountryCode(HANDLE handle, LONG* pVal);
HRESULT __stdcall put_MaxicodeCountryCode(HANDLE handle, LONG val);
HRESULT __stdcall get_MaxicodeZipCode(HANDLE handle, char* lppszValue);
HRESULT __stdcall put_MaxicodeZipCode(HANDLE handle, const char* lpszValue);
HRESULT __stdcall get_Picture(HANDLE handle, IPictureDisp** pPicture);

HRESULT __stdcall get_IPersistStreamInit(HANDLE handle, IPersistStreamInit** pInit);

void    __stdcall mbxAbout(HANDLE handle);
HRESULT __stdcall mbxExportImage(HANDLE handle, const char* lpszFileName, LONG imageFormat);
HRESULT __stdcall mbxExportImage2(HANDLE handle, IDispatch* pStream, LONG imageFormat);
HRESULT __stdcall mbxLoad(HANDLE handle, const char* lpszFileName, LONG persistFormat);
HRESULT __stdcall mbxSave(HANDLE handle, const char* lpszFileName, LONG persistFormat);

/** SymbologyEnum contains all valid symbologies we support */
typedef enum SymbologyEnum
{
	mbxCode39 = 0,				/* Normal Code 39 */
	mbxCode39_Full_ASCII = 1,	/* Code 39 Full ASCII */
	mbxCode39_HIBC=2,			/* Code39 with checksum digit */
	mbxCodaBar=3,				/* Codabars */
	mbxCode93=4,				/* Code 93 */
	mbxCode128=5,				/* Code 128 */
	mbxUCC_EAN_128=6,			/* UCC/EAN 128 */
	mbxInterleaved_2of5=7,		/* Interleaved 2 of 5 */
	mbxUPC_A=8,					/* UPC A */
	mbxUPC_E=9,					/* UPC E */
	mbxEAN_13=10,				/* EAN 13 */
	mbxEAN_8=11,				/* EAN 8 */
	mbxBookland=12,				/* Bookland */
	mbxTelepen=13,				/* Telepen */
	mbxTelepenNumeric=14,		/* Telepen Numeric */
	mbxPostnet=20,				/* Postnet */
	mbxPlanet=21,				/* Planet */
	mbxRoyalMail=22,			/* RoyalMail */
	mbxMSI_Plessey=30,			/* MSI/Plessey */
	mbxCode25=31,				/* Code25 */
	mbxCode11=32,			    /* Code11 */
	/* GS1 DataBar Series, added in 3.4 */
	mbxDataBar=33,				/* GS1 DataBar */
	mbxDataBarTruncated=34,     /* GS1 DataBar Truncated */
	mbxDataBarStacked=35,       /* DataBar Stacked */
	mbxDataBarStackedOmni=36,   /* DataBar Stacked Omnidirectional */
	mbxDataBarLimited=37,       /* DataBar Limited */
	mbxDataBarExpanded=38,      /* DataBar Expanded */
	
	mbxPDF417=40,				/* PDF417 */
	mbxDataMatrix=41,			/* DataMatrix */
	mbxMaxiCode=42				/* MaxiCode	 */
} SymbologyEnum;

typedef enum MeasurementEnum
{
	mbxMeasureMetrics = 1,		/** Metric measurement  */
	mbxMeasureEnglish = 0		/** U.S. English measurment units */
} MeasurementEnum;

typedef enum RotationEnum
{
	mbxRTZeroDegree = 0,
	mbxRTAntiClockwise_90 = 1,
	mbxRTAntiClockwise_180 = 2,
	mbxRTAntiClockwise_270 = 3
} RotationEnum;

typedef enum BorderStyleEnum
{
	mbxBorderStyleNone=0,
	mbxBorderStyleSolid=1,
	mbxBorderStyleDash=2,
	mbxBorderStyleDot=3,
	mbxBorderStyleDashDot=4,
	mbxBorderStyleDashDotDot=5,
} BorderStyleEnum;

typedef enum AlignmentEnum
{
	mbxAlignLeft = 0x00,
	mbxAlignRight = 0x01,
	mbxAlignCenter = 0x02,
	mbxAlignJustify = 0x03
} AlignmentEnum;

typedef enum PersistFormatEnum 
{
		mbxPersistBinary = 0,
		mbxPersistXML = 1
} PersistFormatEnum;

typedef enum ImageFormatEnum
{
	mbxFormatBMP=0,
	mbxFormatJPG=1,
	mbxFormatGIF=2,
	mbxFormatTIF=3,
	mbxFormatPNG=5,
	mbxFormatEMF=6,
	mbxFormatWMF=7,
} ImageFormatEnum;

typedef enum DataMatrixTargetSizeEnum
{
	mbxDMTargetSizeAuto = 0,
	mbxDMTargetSize_10X10=30,
	mbxDMTargetSize_12X12=1,
	mbxDMTargetSize_14X14=2,
	mbxDMTargetSize_16X16=3,
	mbxDMTargetSize_18X18=4,
	mbxDMTargetSize_20X20=5,
	mbxDMTargetSize_22X22=6,
	mbxDMTargetSize_24X24=7,
	mbxDMTargetSize_26X26=8,
	mbxDMTargetSize_32X32=9,
	mbxDMTargetSize_36X36=10,
	mbxDMTargetSize_40X40=11,
	mbxDMTargetSize_44X44=12,
	mbxDMTargetSize_48X48=13,
	mbxDMTargetSize_52X52=14,
	mbxDMTargetSize_64X64=15,
	mbxDMTargetSize_72X72=16,
	mbxDMTargetSize_80X80=17,  
    mbxDMTargetSize_88X88=18,
	mbxDMTargetSize_96X96=19,
	mbxDMTargetSize_104X104=20,
	mbxDMTargetSize_120X120=21,
	mbxDMTargetSize_132X132=22,
	mbxDMTargetSize_144X144=23,
	mbxDMTargetSize_8X18=24,
	mbxDMTargetSize_8X32=25,
    mbxDMTargetSize_12X26=26,
	mbxDMTargetSize_12X36=27,
	mbxDMTargetSize_16X36=28,
	mbxDMTargetSize_16X48=29
} DataMatrixTargetSizeEnum;


#ifdef __cplusplus
}
#endif  /* __cplusplus */
#endif  /* MRVBARDLL_H_ */